%define with()          %{expand:%%{?with_%{1}:1}%%{!?with_%{1}:0}}
%define without()       %{expand:%%{?with_%{1}:0}%%{!?with_%{1}:1}}
%define bcond_with()    %{expand:%%{?_with_%{1}:%%global with_%{1} 1}}
%define bcond_without() %{expand:%%{!?_without_%{1}:%%global with_%{1} 1}}

%bcond_with gwt_native

%define wfk_major 1
%define wfk_minor 0
%define wfk_rev 0

%define gwtver 1.6.4
%define richfacesver 3.3.0
%define springver 2.5.6.SEC01
%define strutsver 1.3.8

Name:           jboss-wfk
Version:        %{wfk_major}.%{wfk_minor}.%{wfk_rev}
Release:        22%{?dist}
Epoch:          0
Summary:        JBoss WFK monolithic zip
License:        LGPLv2
Group:          Development/Installer
URL:            http://www.jboss.org/
Source99:       JBossEULA.txt
BuildRequires: gwt
%if 0
BuildRequires: gwt-manual
%endif
BuildRequires: gwt-javadoc
BuildRequires: gwt-zip
BuildRequires: gwt-src-zip
#BuildRequires: richfaces-demo
BuildRequires: richfaces-manual
BuildRequires: richfaces-javadoc
BuildRequires: richfaces-zip
BuildRequires: richfaces-src-zip
BuildRequires: spring2-manual
BuildRequires: spring2-javadoc
BuildRequires: spring2-zip
#BuildRequires: spring2-src-zip
BuildRequires: struts-manual
BuildRequires: struts-javadoc
BuildRequires: struts-zip
BuildRequires: struts-src-zip
BuildRequires: unzip
BuildRequires: zip
BuildArch:     noarch
BuildRoot:     %{_tmppath}/%{name}-%{version}-%{release}-root

%description
This package is a container for the JBoss WFK zip.

%package unsupported
Summary:        Unsupported libraries for JBoss WFK
Group:          Development
Requires:       jpackage-utils
Requires:       spring2

%description unsupported
This package contains the unsupported libraries for JBoss WFK.

%package zip
Summary:        Monolithic zip for JBoss WFK
Group:          Development

%description zip
Monolithic .zip for WFK.

%prep
%setup -q -c -T -n %{name}-%{version}

%build
rm -rf jboss-wfk-%{wfk_major}.%{wfk_minor}

# binaries
mkdir -p jboss-wfk-%{wfk_major}.%{wfk_minor}

pushd jboss-wfk-%{wfk_major}.%{wfk_minor}/
    cp -p %{SOURCE99} .
    # spring2
    unzip -qq %{_javadir}/jbossas-fordev/spring-framework-%{springver}.zip
    mkdir -p ../jboss-wfk-%{wfk_major}.%{wfk_minor}-demo/spring2
    pushd ../jboss-wfk-%{wfk_major}.%{wfk_minor}-demo/spring2
    unzip -qq %{_javadir}/jbossas-fordev/spring-framework-%{springver}-with-dependencies.zip 'spring-framework-%{springver}/samples/*'
    mv spring-framework-%{springver}/samples/* .
    rm -r spring-framework-%{springver}/
    popd
    mv spring-framework-%{springver} spring2

    # struts
    unzip -qq %{_javadir}/jbossas-fordev/struts-%{strutsver}-all.zip
    mkdir -p ../jboss-wfk-%{wfk_major}.%{wfk_minor}-demo/struts
    mv struts-%{strutsver}/apps/* ../jboss-wfk-%{wfk_major}.%{wfk_minor}-demo/struts/
    rm -r struts-%{strutsver}/apps
    rm -r struts-%{strutsver}/docs
    rm -r struts-%{strutsver}/src
    mv struts-%{strutsver} struts

    # richfaces
    unzip -qq %{_javadir}/jbossas-fordev/richfaces-ui-%{richfacesver}-bin.zip
    # copy only lib subdirectory, other are already included in documentation
    mkdir richfaces
    mv richfaces-ui-%{richfacesver}/lgpl.txt richfaces/
    mv richfaces-ui-%{richfacesver}/lib richfaces/
    rm -rf richfaces-ui-%{richfacesver}
    #mkdir -p ../jboss-wfk-%{wfk_major}.%{wfk_minor}-demo/richfaces
    #cp -pr %{_datadir}/richfaces-%{richfacesver}/demo/* %{_javadir}/richfaces/{darkX,glassX,laguna}-%{richfacesver}.jar ../jboss-wfk-%{wfk_major}.%{wfk_minor}-demo/richfaces/

    # gwt
%if %with gwt_native
    %{__tar} xjf --exclude 'gwt-linux-%{gwtver}/doc' %{_javadir}/jbossas-fordev/gwt-linux-%{gwtver}.tar.bz2
    mv gwt-linux-%{gwtver} gwt
%else
    unzip -qq %{_javadir}/jbossas-fordev/gwt-%{gwtver}.zip
    mkdir -p ../jboss-wfk-%{wfk_major}.%{wfk_minor}-demo/gwt
    mv gwt-%{gwtver}/samples/* ../jboss-wfk-%{wfk_major}.%{wfk_minor}-demo/gwt/
    rm gwt-%{gwtver}/gwt-dev-linux.jar
%endif
    # delete doc subdirectory, it is already included in documentation
    rm -rf gwt-%{gwtver}/doc
    mv gwt-%{gwtver} gwt
popd
zip -q -9 -r jboss-wfk-%{version}.zip jboss-wfk-%{wfk_major}.%{wfk_minor}
rm -r jboss-wfk-%{wfk_major}.%{wfk_minor}/

# demo
zip -q -9 -r jboss-wfk-demo-%{version}.zip jboss-wfk-%{wfk_major}.%{wfk_minor}-demo
rm -r jboss-wfk-%{wfk_major}.%{wfk_minor}-demo

# docs
mkdir -p jboss-wfk-%{wfk_major}.%{wfk_minor}
pushd jboss-wfk-%{wfk_major}.%{wfk_minor}
    # spring2
    mkdir -p doc/spring2/
    cp -pr %{_docdir}/spring2*/* doc/spring2/
    # javadocdir already included through link in docdir
    #cp -pr %{_javadocdir}/spring2/* doc/spring2/

    # struts
    mkdir -p doc/struts/
    cp -pr %{_docdir}/struts*/* doc/struts/
    # javadocdir already included through link in docdir
    #cp -pr %{_javadocdir}/struts/* doc/struts/

    # richfaces
    mkdir -p doc/richfaces/
    cp -pr %{_docdir}/richfaces*/* doc/richfaces/
    cp -pr %{_javadocdir}/richfaces/* doc/richfaces/

    # gwt
    mkdir -p doc/gwt
    cp -pr %{_docdir}/gwt*/* doc/gwt/
    cp -pr %{_javadocdir}/gwt/* doc/gwt/
popd
zip -q -9 -r jboss-wfk-docs-%{version}.zip jboss-wfk-%{wfk_major}.%{wfk_minor}
rm -r jboss-wfk-%{wfk_major}.%{wfk_minor}

# source
mkdir -p jboss-wfk-%{wfk_major}.%{wfk_minor}-src
pushd jboss-wfk-%{wfk_major}.%{wfk_minor}-src
    mkdir -p spring2 struts richfaces gwt

    # spring2
    pushd spring2
       unzip -qq %{_javadir}/jbossas-fordev/spring-framework-%{springver}-with-dependencies.zip
       rm -r spring-framework-%{springver}/dist/*
       rm -r spring-framework-%{springver}/docs
       rm -r spring-framework-%{springver}/lib/*
       rm -r spring-framework-%{springver}/samples/*
       mv spring-framework-%{springver}/* .
       rmdir spring-framework-%{springver}/
    popd

    # struts
    pushd struts
       unzip -qq %{_javadir}/jbossas-fordev/struts-%{strutsver}-src.zip
       rm -r struts-%{strutsver}/src/apps/*
       mv struts-%{strutsver}/* .
       rmdir struts-%{strutsver}/
    popd

    # richfaces
    pushd richfaces
       unzip -qq %{_javadir}/jbossas-fordev/richfaces-ui-%{richfacesver}-src.zip
       rm -r richfaces-ui-%{richfacesver}/samples/*
       mv richfaces-ui-%{richfacesver}/* .
       rmdir richfaces-ui-%{richfacesver}/
    popd

    # gwt
    pushd gwt
       unzip -qq %{_javadir}/jbossas-fordev/gwt-%{gwtver}-src.zip
       rm -r gwt-%{gwtver}/tools/redist/*
       rm -r gwt-%{gwtver}/samples/*
       rm -r gwt-%{gwtver}/tools/sdk/*
       rm gwt-%{gwtver}/tools/lib/junit/*
       rm gwt-%{gwtver}/tools/lib/tomcat/*
       mv gwt-%{gwtver}/* .
       rmdir gwt-%{gwtver}/
    popd
popd
zip -q -9 -r jboss-wfk-src-%{version}.zip jboss-wfk-%{wfk_major}.%{wfk_minor}-src
rm -r jboss-wfk-%{wfk_major}.%{wfk_minor}-src/

# spring2
mkdir -p jboss-wfk-%{wfk_major}.%{wfk_minor}
pushd jboss-wfk-%{wfk_major}.%{wfk_minor}
unzip -qq %{_javadir}/jbossas-fordev/spring-framework-%{springver}-with-dependencies.zip \
    spring-framework-%{springver}/lib/antlr/antlr-2.7.6.jar \
    spring-framework-%{springver}/lib/aopalliance/aopalliance.jar \
    spring-framework-%{springver}/lib/aspectj/aspectjrt.jar \
    spring-framework-%{springver}/lib/aspectj/aspectjweaver.jar \
    spring-framework-%{springver}/lib/bsh/bsh-2.0b4.jar \
    spring-framework-%{springver}/lib/cglib/cglib-nodep-2.1_3.jar \
    spring-framework-%{springver}/lib/dom4j/dom4j-1.6.1.jar \
    spring-framework-%{springver}/lib/hibernate/hibernate3.jar \
    spring-framework-%{springver}/lib/hibernate/hibernate-annotations.jar \
    spring-framework-%{springver}/lib/hibernate/hibernate-commons-annotations.jar \
    spring-framework-%{springver}/lib/hibernate/hibernate-configuration-3.0.dtd \
    spring-framework-%{springver}/lib/hibernate/hibernate-entitymanager.jar \
    spring-framework-%{springver}/lib/hibernate/hibernate-mapping-3.0.dtd \
    spring-framework-%{springver}/lib/j2ee/activation.jar \
    spring-framework-%{springver}/lib/j2ee/common-annotations.jar \
    spring-framework-%{springver}/lib/j2ee/connector.jar \
    spring-framework-%{springver}/lib/j2ee/ejb-api.jar \
    spring-framework-%{springver}/lib/j2ee/el-api.jar \
    spring-framework-%{springver}/lib/j2ee/jaxrpc.jar \
    spring-framework-%{springver}/lib/j2ee/jms.jar \
    spring-framework-%{springver}/lib/j2ee/jsp-api.jar \
    spring-framework-%{springver}/lib/j2ee/jstl.jar \
    spring-framework-%{springver}/lib/j2ee/jta.jar \
    spring-framework-%{springver}/lib/j2ee/mail.jar \
    spring-framework-%{springver}/lib/j2ee/persistence.jar \
    spring-framework-%{springver}/lib/j2ee/rowset.jar \
    spring-framework-%{springver}/lib/j2ee/servlet-api.jar \
    spring-framework-%{springver}/lib/javassist/javassist-3.4.GA.jar \
    spring-framework-%{springver}/lib/jmx/jmxremote_optional.jar \
    spring-framework-%{springver}/lib/jakarta-commons/commons-beanutils.jar \
    spring-framework-%{springver}/lib/jakarta-commons/commons-collections.jar \
    spring-framework-%{springver}/lib/jakarta-commons/commons-dbcp.jar \
    spring-framework-%{springver}/lib/jakarta-commons/commons-digester.jar \
    spring-framework-%{springver}/lib/jakarta-commons/commons-fileupload.jar \
    spring-framework-%{springver}/lib/jakarta-commons/commons-httpclient.jar \
    spring-framework-%{springver}/lib/jakarta-commons/commons-io.jar \
    spring-framework-%{springver}/lib/jakarta-commons/commons-logging.jar \
    spring-framework-%{springver}/lib/jakarta-commons/commons-pool.jar \
    spring-framework-%{springver}/lib/jakarta-taglibs/standard.jar \
    spring-framework-%{springver}/lib/jakarta-commons/commons-validator.jar \
    spring-framework-%{springver}/lib/log4j/log4j-1.2.14.jar \
    spring-framework-%{springver}/lib/quartz/quartz-all-1.6.0.jar \
    spring-framework-%{springver}/lib/slf4j/slf4j-api-1.5.0.jar \
    spring-framework-%{springver}/lib/slf4j/slf4j-log4j12-1.5.0.jar
mkdir -p spring2/lib
mv spring-framework-%{springver}/lib/* spring2/lib/
rm -r spring-framework-%{springver}/
popd
zip -q -9 -r jboss-wfk-unsupported-%{version}.zip jboss-wfk-%{wfk_major}.%{wfk_minor}
rm -r jboss-wfk-%{wfk_major}.%{wfk_minor}

%install
rm -rf %{buildroot}

unzip -qq jboss-wfk-unsupported-%{version}.zip
mkdir -p %{buildroot}%{_javadir}/spring2/unsupported
cp -pr jboss-wfk-%{wfk_major}.%{wfk_minor}/spring2/lib/* %{buildroot}%{_javadir}/spring2/unsupported/
rm -r jboss-wfk-%{wfk_major}.%{wfk_minor}/

mkdir -p %{buildroot}%{_javadir}/jbossas-fordev/
install -p -m 644 *.zip %{buildroot}%{_javadir}/jbossas-fordev/

%clean
rm -rf %{buildroot}

%files unsupported
%defattr(0644,root,root,0755)
%{_javadir}/spring2/unsupported

%files zip
%defattr(0644,root,root,0755)
%dir %{_javadir}/jbossas-fordev
%{_javadir}/jbossas-fordev/jboss-wfk-%{version}.zip
%if %with gwt_native
%{_javadir}/jbossas-fordev/jboss-wfk-linux32-%{version}.zip
%{_javadir}/jbossas-fordev/jboss-wfk-windows-%{version}.zip
%endif
%{_javadir}/jbossas-fordev/jboss-wfk-demo-%{version}.zip
%{_javadir}/jbossas-fordev/jboss-wfk-docs-%{version}.zip
%{_javadir}/jbossas-fordev/jboss-wfk-src-%{version}.zip
%{_javadir}/jbossas-fordev/jboss-wfk-unsupported-%{version}.zip

%changelog
* Tue Jun 02 2009 David Walluck <dwalluck@redhat.com> 0:1.0.0-22
- rebuild for spring2

* Tue Jun 02 2009 David Walluck <dwalluck@redhat.com> 0:1.0.0-21
- add .dtd files for spring2

* Mon Jun 01 2009 David Walluck <dwalluck@redhat.com> 0:1.0.0-20
- rebuild for spring2

* Mon Jun 01 2009 David Walluck <dwalluck@redhat.com> 0:1.0.0-19
- rebuild

* Fri May 29 2009 David Walluck <dwalluck@redhat.com> 0:1.0.0-18
- remove struts apps directory

* Fri May 29 2009 David Walluck <dwalluck@redhat.com> 0:1.0.0-17
- revert dependencies to what they were as of 0:1.0.0-14

* Thu May 28 2009 David Walluck <dwalluck@redhat.com> 0:1.0.0-16
- don't include struts directory in unsupported zip
- rebuild for richfaces

* Wed May 27 2009 David Walluck <dwalluck@redhat.com> 0:1.0.0-15
- remove tomcat from gwt
- rebuild for richfaces
- add demo zip
- add unsupported rpm and zip

* Fri May 15 2009 David Walluck <dwalluck@redhat.com> 0:1.0.0-14
- remove junit src zip from src

* Thu May 14 2009 David Walluck <dwalluck@redhat.com> 0:1.0.0-13
- remove gwt-dev-linux.jar if built without native
- remove junit-3.8.1.jar from gwt
- remove samples from src
- always fix gwt docs regardless of native
- rebuild for richfaces

* Tue May 12 2009 David Walluck <dwalluck@redhat.com> 0:1.0.0-12
- rebuild for struts changes

* Wed May 06 2009 Martha Benitez <mbenitez@redhat.com> 0:1.0.0-11
- Remove samples from gwt and apps from struts.

* Mon May 04 2009 David Walluck <dwalluck@redhat.com> 0:1.0.0-10
- remove old build directory before building

* Mon May 04 2009 Martha Benitez <mbenitez@redhat.com> 0:1.0.0-9
- Make changes to avoid documentation duplicates

* Fri May 01 2009 David Walluck <dwalluck@redhat.com> 0:1.0.0-8
- relocate some documentation

* Tue Apr 21 2009 David Walluck <dwalluck@redhat.com> 0:1.0.0-7
- update EULA

* Fri Apr 17 2009 David Walluck <dwalluck@redhat.com> 0:1.0.0-6
- use gwt noarch zip

* Tue Apr 14 2009 David Walluck <dwalluck@redhat.com> 0:1.0.0-5
- remove binaries from gwt src
- include windows cmd files in gwt bin

* Thu Apr 09 2009 David Walluck <dwalluck@redhat.com> 0:1.0.0-4
- exclude docs and lib directories from spring2 in jboss-wfk-src zip

* Thu Apr 09 2009 David Walluck <dwalluck@redhat.com> 0:1.0.0-3
- use spring-framework-%%{version}.zip

* Thu Apr 09 2009 David Walluck <dwalluck@redhat.com> 0:1.0.0-2
- remove gwt native bits

* Fri Apr 03 2009 David Walluck <dwalluck@redhat.com> 0:1.0.0-1
- fix gwt windows zip name

* Fri Apr 03 2009 David Walluck <dwalluck@redhat.com> 0:1.0.0-0.CR1.0.5
- split into three zips: noarch, linux32, windows

* Thu Apr 02 2009 David Walluck <dwalluck@redhat.com> 0:1.0.0-0.CR1.0.4
- silence tar output

* Thu Apr 02 2009 David Walluck <dwalluck@redhat.com> 0:1.0.0-0.CR1.0.3
- use unversioned directories

* Wed Apr 01 2009 David Walluck <dwalluck@redhat.com> 0:1.0.0-0.CR1.0.2
- only include gwt native bits on %%{ix86}

* Fri Jan 30 2009 Permaine Cheung <pcheung@redhat.com> 0:1.0.0-0.CR1.0.1
- skeleton for jboss-wfk build
